<?php
/**
 * @version		1.1.0
 * @package		Joomla
 * @subpackage	Edocman
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2011 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die ;
jimport('joomla.application.component.modeladmin');
/**
 * Edocman Component Document Model
 *
 * @package		Joomla
 * @subpackage	EDocman
 * @since 1.5
 */
class EdocmanModelDocument extends JModelAdmin
{				
	/**
	 * Document data
	 *
	 * @var array
	 */
	var $_data = null;	
	/**
	 * Constructor function
	 *
	 */
    public function __construct($config = array()) {
	    //Ininitial event for action on document
        if (!isset($config['event_after_delete'])) {
            $config['event_after_delete'] = 'onDocumentAfterDelete' ;
        }	        
	    if (!isset($config['event_after_save'])) {
            $config['event_after_save'] = 'onDocumentAfterSave' ;
        }        
	    if (!isset($config['event_before_delete'])) {
            $config['event_before_delete'] = 'onDocumentBeforeDelete' ;
        }        
	    if (!isset($config['event_before_save'])) {
            $config['event_before_save'] = 'onDocumentBeforeSave' ;
        }
	    if (!isset($config['event_change_state'])) {
            $config['event_change_state'] = 'onDocumentChangeState' ;
        }
        
        parent::__construct($config) ;
	}
	/**
	 * Get document detail
	 *
	 * @return object
	 */
	function getData() {
		if (empty($this->_data)) {
			$id = JRequest::getInt('id', 0) ;
			$sql = 'SELECT a.*, b.title AS license_title FROM #__edocman_documents AS a LEFT JOIN #__edocman_licenses AS b ON a.license_id=b.id WHERE a.id='.$id;
			$this->_db->setQuery($sql) ;
			$this->_data = $this->_db->loadObject();	
		}						
		return $this->_data ;
	}		

	
	function canDownload($recordId) {
	    $user = & JFactory::getUser() ;
	    $userId = $user->get('id');
	    $document = $this->getData() ;
	    if (!$document)
	        return false ;
	    $assetName = 'com_edocman.document.'.$recordId ;
	    if (($document->user_ids == "" && ($user->authorise('edocman.download', $assetName) || $user->authorise('core.edit', $assetName) || ($userId == $document->created_user_id))) || ($document->user_ids && in_array($userId, explode(',', $document->user_ids))))
	        return true ;
	    else 
	        return false ;            
	}
	/**
	 * Increase hits for document
	 * 
	 */	
	function hitCounter() {
	    $session = & JFactory::getSession() ;
	    $viewedDocIds = $session->get('viewed_doc_ids', '') ;
	    if ($viewedDocIds) {
	        $viewedDocIds =  explode(',', $viewedDocIds) ;
	    } else {
	        $viewedDocIds = array() ;
	    }	    
	    if (!in_array($this->_data->id, $viewedDocIds)) {
	        $db = & JFactory::getDbo() ;
	        //Update hits counter
	        $sql = 'UPDATE #__edocman_documents SET hits = hits + 1 WHERE id='.$this->_data->id ;
	        $db->setQuery($sql) ;
	        $db->query() ;
	        $viewedDocIds[] = $this->_data->id ;
	    }        	    	    
	    $viewedDocIds = implode(',', $viewedDocIds) ;
	    $session->set('viewed_doc_ids', $viewedDocIds);
	}
			
	/**
	 * Process downloading document
	 * 
	 * @param int $documentId ID of the document which will be downloaded
	 * @param boolean true if the document will be downloaded, false if the document is viewed
	 */
	function download($documentId, $download = true) {
	    $app = JFactory::getApplication();
	    $user = & JFactory::getUser() ;
	    
	    $db = & JFactory::getDbo() ;
	    $sql = 'SELECT * FROM #__edocman_documents WHERE id='.$documentId ;
	    $db->setQuery($sql) ;
	    $table = $db->loadObject() ;

	    
	    $sql = 'UPDATE #__edocman_documents SET downloads=downloads + 1 WHERE id='.$documentId;
	    $db->setQuery($sql) ;
	    $db->query();
	                           
        if ($table->document_url) {
            $app->redirect($table->document_url);
        } else {
            $config = EdocmanHelper::getConfig() ;
    	    $rootDir = $config->documents_path ;        	   
    	    $filePath = $rootDir.'/'.$table->filename ;    	        	        	      
    	    //Logs
    	    if ($config->download_log) {
    	        jimport('joomla.environment.browser') ;
        	    $browser = JBrowser::getInstance();	    
        	    $row = $this->getTable('statistic', 'EdocmanTable');
        	    $row->document_id = $documentId ;
        	    $row->user_id = $user->get('id');
        	    $row->user_ip = @$_SERVER['REMOTE_ADDR'] ;
        	    $row->download_time = date('Y-m-d H:i:s');
        	    $row->browser = $browser->getBrowser() ;
        	    $row->os = $browser->getPlatform() ;
        	    $row->store() ;
    	    }    	    
    	    //Send notification email
    	    if ($config->download_notification) {
    	        $jconfig = new JConfig() ;
    	        $subject = $config->download_email_subject ;
    	        $body = nl2br($config->download_email_body) ;

    	        if ($user->id) {
    	            $username = $user->username ;
    	            $name = $user->name ;
    	        } else {
    	            $username = JText::_('EDOCMAN_GUEST');
    	            $name = JText::_('EDOCMAN_GUEST');
    	        }    	        
    	        $userIp = @$_SERVER['REMOTE_ADDR'] ;
    	        $documentTitle = $table->title ;
    	        $body = str_replace('[USERNAME]', $username, $body) ;
    	        $body = str_replace('[NAME]', $name, $body) ;
    	        $body = str_replace('[USER_IP]', $userIp, $body) ;
    	        $body = str_replace('[DOCUMENT_TITLE]', $documentTitle, $body) ;
    	        $notificationEmails = trim($config->notification_emails);
    	        if (strlen($notificationEmails) < 5) {
    	            $notificationEmails = $jconfig->mailfrom ;
    	        }  
    	        $notificationEmails = explode(',', $notificationEmails) ;
    	        for ($i = 0 , $n = count($notificationEmails) ; $i < $n ; $i++) {
    	             $email = trim($notificationEmails[$i]) ;
    	             if ($email) {
    	                 JUtility::sendMail($jconfig->mailfrom, $jconfig->fromname, $email, $subject, $body, 1) ;
    	             }       
    	        }  	            	            	        
    	    }    	        	        	   
    	    while (@ob_end_clean());	    	        	    
    	    EdocmanHelper::processDownload($filePath, $table->filename, $table->original_filename, $download) ;
    	    $app->close(0) ;	         
        }        	    	    
	}	
			
	################################Re-using back-end code in the front-end######################################
	
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = 'Document', $prefix = 'EdocmanTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	/**
	 * Method to get the record form.
	 *
	 * @param	array	$data		An optional array of data for the form to interogate.
	 * @param	boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return	JForm	A JForm object on success, false on failure
	 * @since	1.6
	 */
	public function getForm($data = array(), $loadData = true)
	{
		// Initialise variables.									
		JForm::addFormPath(JPATH_ADMINISTRATOR.'/components/com_edocman/models/forms');
		JForm::addFieldPath(JPATH_ADMINISTRATOR.'/components/com_edocman/models/fields');

		// Get the form.
		$form = $this->loadForm('com_edocman.document', 'document', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}        
		
		if (empty($data))
			$data = $this->loadFormData() ;
		
	    if (!$this->canEditState((object) $data)) {
			// Disable fields for display.			
			$form->setFieldAttribute('published', 'disabled', 'true');
            $form->setFieldAttribute('published', 'filter', 'unset');								
		}				
		
		$form->setFieldAttribute('filename', 'directory', JPATH_ROOT.'/edocman');						
		$id = JRequest::getInt('id', 0) ;		
		if ($id) {
		    $db = & JFactory::getDbo() ;
		    $sql = 'SELECT category_id FROM #__edocman_document_category WHERE document_id='.$id ;
		    $db->setQuery($sql) ;
		    $categoryId = $db->loadResult() ;		    		    		    			 
		}  else {			
		    $categoryId = JRequest::getInt('category_id', 0) ;					    		   
		}		
		$form->setFieldAttribute('category_id', 'readonly',  true);		
		$form->setFieldAttribute('category_id', 'value',  $categoryId);
				
		return $form;
	}

	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return	mixed	The data for the form.
	 * @since	1.6
	 */
	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_edocman.edit.document.data', array());

		if (empty($data)) {
			$data = $this->getItem();
		}

		return $data;
	}
	/**
	 * Prepare and sanitise the table prior to saving.
	 *
	 * @since	1.6
	 */
	protected function prepareTable(&$table)
	{
		jimport('joomla.filter.output');
		if (empty($table->id)) {
			// Set ordering to the last item if not set
			if (@$table->ordering === '') {
				$db = JFactory::getDbo();
				$db->setQuery('SELECT MAX(ordering) FROM #__edocman_documents');
				$max = $db->loadResult();
				$table->ordering = $max+1;
			}
		}						
	}		
	/**
	 * Method to save the form data.
	 *
	 * @param	array	The form data.
	 * @return	boolean	True on success.
	 * @since	1.6
	 */
	public function save($data)
	{
	    jimport('joomla.filesystem.file') ;	    
		// Initialise variables;
		$app =  JFactory::getApplication() ;
		$dispatcher = JDispatcher::getInstance();
		JPluginHelper::importPlugin('edocman') ;
		$table		= $this->getTable();
		$pk			= (!empty($data['id'])) ? $data['id'] : (int)$this->getState($this->getName().'.id');
		$isNew		= true;		
		$config = EdocmanHelper::getConfig() ;				
		// Load the row if saving an existing document
		if ($pk > 0) {
			$table->load($pk);
			$isNew = false;
		}		
		// Bind the data.
		if (!$table->bind($data, array('image', 'filename'))) {
			$this->setError($table->getError());
			return false;
		}							
		//Processing file upload		
		if ($isNew && (!$_FILES['jform']['name']['filename'] && empty($data['document_url']))) {
		    $this->setError(JText::_('EDOCMAN_NO_FILE_UPLOADED'));
		    return false ;
		}			
		$categoryId = (int) $data['category_id'] ;
		if ($categoryId == 0) {
		    $this->setError(JText::_('EDOCMAN_CHOOSE_CATEGORY')) ;
		    return false ;
		}		
	    if (is_uploaded_file($_FILES['jform']['tmp_name']['filename'])) {		     
		    $rootDir =  EdocmanHelper::getConfigValue('documents_path') ;
		    $fileName = $_FILES['jform']['name']['filename'];
		    $fileSize = $_FILES['jform']['size']['filename'] ;		    
		    $maxFilesize = $config->max_file_size ? $config->max_file_size : 2 ;
		    $maxFilesizeType = $config->max_filesize_type ? $config->max_filesize_type : 3 ;
            $maxFilesizeInBye = 2*1024*1024 ; ;
		    switch ($maxFilesizeType) {
		        case 1 :
                     $maxFilesizeInBye = $maxFilesize ;
                     break ;
		        case 2 :
                     $maxFilesizeInBye = $maxFilesize*1024 ;
                     break ;
		        case 3 :
		             $maxFilesizeInBye = $maxFilesize*1024*1024 ;
		             break ;		                    		            
		    }		    
		    if ($maxFilesizeInBye < $fileSize) {
		        $msg = JText::_('The file you tried to upload is too big. Maximum filesize allowed is '.$maxFilesizeInBye.' byes');
		        $this->setError($msg) ;
		        return false ;
		    }		    
		    //Check file extension
		    $fileExt = strtolower(JFile::getExt($fileName)) ;
		    $allowedFileTypes = explode(',', $config->allowed_file_types) ;
		    for($i = 0 , $n = count($allowedFileTypes) ; $i < $n ; $i++) {
		        $allowedFileTypes[$i] = strtolower(trim($allowedFileTypes[$i])) ;
		    }
		    if (!in_array($fileExt, $allowedFileTypes)) {		        
		       $msg = JText::_('The file you uploaded is not allowed. Only files with following extension are accepted '.$config->allowed_file_types);
		       $this->setError($msg) ;
		       return false ;     		        
		    }		    
		    //Make filename safe		    
		    $fileName = JFile::makeSafe($fileName) ;	
            $db = $this->getDbo() ;		    
		    $sql = 'SELECT `path` FROM #__edocman_categories WHERE id = '.$categoryId ;
		    $db->setQuery($sql) ;
		    $path = $db->loadResult() ;

	        if ($path) {
		        $savedFilePath = $rootDir.'/'.$path.'/'.$fileName ;
		    } else {
		        $savedFilePath = $rootDir.'/'.$fileName ;
		    }
		    if (JFile::exists($savedFilePath)) {
		        $savedFilename = uniqid('file_').'_'.$fileName; 
		    } else {
		        $savedFilename = $fileName ;
		    }		    		    		   
		    $categoryId = (int)$data['category_id'];		    
		    if ($path) {
		        JFile::upload($_FILES['jform']['tmp_name']['filename'], $rootDir.'/'.$path.'/'.$savedFilename) ;
		    } else {
		        JFile::upload($_FILES['jform']['tmp_name']['filename'], $rootDir.'/'.$savedFilename) ;    
		    }            
		    if ($path)
		    	$table->filename = $path.'/'.$savedFilename ;
		    else
		    	$table->filename = $savedFilename ;		    		    		    		 
		} elseif (isset($data['select_filename']) && $data['select_filename']) {
		    $table->filename = $data['select_filename'] ;
		}
						
		if (is_uploaded_file($_FILES['jform']['tmp_name']['image'])) {		     
		     $canUpload = true ;
		     if (!getimagesize($_FILES['jform']['tmp_name']['image'])) {
		         $app->enqueueMessage(JText::_('COM_EDOCMAN_IMAGE_ERROR'), 'error') ;
		         $canUpload = false ;		         
		     }		     
		     //XSS checking
    		$xss_check =  JFile::read($_FILES['jform']['tmp_name']['image'], false, 256);
    		$html_tags = array('abbr', 'acronym', 'address', 'applet', 'area', 'audioscope', 'base', 'basefont', 'bdo', 'bgsound', 'big', 'blackface', 'blink', 'blockquote', 'body', 'bq', 'br', 'button', 'caption', 'center', 'cite', 'code', 'col', 'colgroup', 'comment', 'custom', 'dd', 'del', 'dfn', 'dir', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'fn', 'font', 'form', 'frame', 'frameset', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'hr', 'html', 'iframe', 'ilayer', 'img', 'input', 'ins', 'isindex', 'keygen', 'kbd', 'label', 'layer', 'legend', 'li', 'limittext', 'link', 'listing', 'map', 'marquee', 'menu', 'meta', 'multicol', 'nobr', 'noembed', 'noframes', 'noscript', 'nosmartquotes', 'object', 'ol', 'optgroup', 'option', 'param', 'plaintext', 'pre', 'rt', 'ruby', 's', 'samp', 'script', 'select', 'server', 'shadow', 'sidebar', 'small', 'spacer', 'span', 'strike', 'strong', 'style', 'sub', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'title', 'tr', 'tt', 'ul', 'var', 'wbr', 'xml', 'xmp', '!DOCTYPE', '!--');
    		foreach($html_tags as $tag) {
    			// A tag is '<tagname ', so we need to add < and a space or '<tagname>'
    			if(stristr($xss_check, '<'.$tag.' ') || stristr($xss_check, '<'.$tag.'>')) {
    				JError::raiseWarning(100, JText::_('IE XSS Warning'));
    				$canUpload = false ;    				
    			}    			
    		}    
    		$ret = true ;		     		
    		if ($canUpload) {
    		    //Process upload if there are no error found
    		    $documentImagePath = JPATH_ROOT.'/media/com_edocman/document/';
    		    $thumbDocumentImagePath = $documentImagePath.'thumbs/' ;
    		    $fileName = uniqid('category_').$_FILES['jform']['name']['image'];    		    
    		    $ret = JFile::upload($_FILES['jform']['tmp_name']['image'], $documentImagePath.$fileName) ;
    		    if ($ret) {
    		        //TODO : Get the width and height of image from config data
    		        $ret = EdocmanHelper::resizeImage($documentImagePath.$fileName, $thumbDocumentImagePath.$fileName, 100, 100, 95) ;    		        
    		    }        		    
    		}	     	
    		if ($ret) {    		 
    		    if($table->image) {
    		        if (JFILE::exists($documentImagePath.$table->image))    
    		            JFile::delete($documentImagePath.$table->image) ;
    		        if (JFILE::exists($thumbDocumentImagePath.$table->image))    
    		            JFile::delete($thumbDocumentImagePath.$table->image) ;        		            		            		       
    		    }       		    
    		    $table->image = $fileName ;    		    
    		}	        		    
		}
						
		// Check the data.
		if (!$table->check()) {
			$this->setError($table->getError());
			return false;
		}

		// Trigger the onContentBeforeSave event.
		$result = $dispatcher->trigger($this->event_before_save, array($this->option.'.'.$this->name, &$table, $isNew));
		if (in_array(false, $result, true)) {
			$this->setError($table->getError());
			return false;
		}

		#Customized follow the requirement at forum post #18040
		if ($isNew) {
			$user = & JFactory::getUser() ;
			$table->user_ids = $user->get('id');
		}
		#end customization
		
		// Store the data.
		if (!$table->store()) {
			$this->setError($table->getError());
			return false;
		}
        		
		$dispatcher->trigger($this->event_after_save, array($this->option.'.'.$this->name, &$table, $isNew));
			
		$this->setState($this->getName().'.id', $table->id);
		
		if ($isNew && $config->upload_notification) {
			EdocmanHelper::sendUploadNotificationEmail($table, $config);	
		}
		// Clear the cache
		$this->cleanCache();
		
		
		//Store the category in URL
		JRequest::setVar('category_id', $data['category_id'], 'post') ;

		return true;
	}		

	
	protected function canDelete($record)
	{		
		if ($record->asset_id == 0) {
			return true ;
		}
		if (!empty($record->id)) {
			$user = JFactory::getUser();
			return $user->authorise('core.delete', 'com_edocman.document.'.(int) $record->id);
		}
	}

	
	protected function canEditState($record)
	{
		$user = JFactory::getUser();		
		if ($record->category_id)
			$categoryId = $record->category_id ;
		else
			$categoryId = JRequest::getInt('category_id') ;			
		if ($record->id) {
			return $user->authorise('core.edit.state', 'com_edocman.document.'.$record->id) ;
		} elseif ($categoryId) {
			return $user->authorise('core.edit.state', 'com_edocman.category.'.$categoryId) ;
		} else
			return parent::canEditState($record) ;
	}
} 